package schedule.ejb;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.jboss.varia.scheduler.Schedulable;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public class CurrencyUpdater implements Schedulable {
	
	private Map<String,Float> cMap = new HashMap<String,Float>();
	private static String urlCurrrencyString = "http://localhost:8080/scheduler/currency.xml";
	
	public CurrencyUpdater() {
		super();
	}
	
	public static void main(String[] args) {
		CurrencyUpdater currencyUpdater = new CurrencyUpdater();
		try {
			currencyUpdater.insertCurrencyTable();
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		}

	}

	private void parseURL(String url) throws IOException, SAXException
	  {
		
	    DOMParser parser = new DOMParser();
		parser.parse(url);
	    Element element = parser.getDocument().getDocumentElement();
	    NodeList pages = element.getElementsByTagName("Day");
	    for (int i = 0, maxCount = pages.getLength(); i < maxCount; i++)
	    {
	    	Element e = (Element)pages.item(i);
	    	cMap.put(e.getAttribute("currency"), Float.valueOf(e.getAttribute("rate")));
	    }
	    
	}
	
	private void insertCurrencyTable() throws SQLException, IOException, SAXException{
		
		parseURL("currency.xml");
		Connection conn = getMySQLConnection();
		PreparedStatement psInsertCurrency = conn.prepareStatement("insert into schedule_table set currency=?,value=?");
		for(String s : cMap.keySet()){
			psInsertCurrency.setString(1, s);
			psInsertCurrency.setFloat(2, cMap.get(s));
			psInsertCurrency.executeUpdate();
			psInsertCurrency.clearParameters();
		}
		psInsertCurrency.close();
		conn.close();
	}
	
	private void updateCurrencyTableByCurrencyCode() throws SQLException{
		
		Connection conn = getMySQLConnection();
		PreparedStatement psInsertCurrency = conn.prepareStatement("update schedule_table set value=? where currency=?");
		for(String s : cMap.keySet()){
			psInsertCurrency.setFloat(1, cMap.get(s));
			psInsertCurrency.setString(2, s);
			psInsertCurrency.executeUpdate();
			psInsertCurrency.clearParameters();
		}
		psInsertCurrency.close();
		conn.close();
	}

	public void perform(Date arg0, long arg1) {
		
		try {
			parseURL(urlCurrrencyString);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		}
		
		try {
			updateCurrencyTableByCurrencyCode();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}
	
	private Connection getMySQLConnection(){
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		String url = "jdbc:mysql://localhost:3306/schedule";
		Connection con = null;
		try {
			con = (Connection) DriverManager.getConnection(url, "root","");
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return con;
	}
}
